// TicView.cpp : implementation of the CTicView class
//

#include "stdafx.h"
#include "Tic.h"

#include "TicDoc.h"
#include "TicView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTicView

IMPLEMENT_DYNCREATE(CTicView, CView)

BEGIN_MESSAGE_MAP(CTicView, CView)
	//{{AFX_MSG_MAP(CTicView)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTicView construction/destruction

CTicView::CTicView()
{
	// TODO: add construction code here
	for (int i=0; i<m; i++) { 
	    for (int j=0; j<l; j++) { 
		     int x = (i * 100) + 70; 
		     int y = - (j * 100) - 70; 

		m_rect[i][j].SetRect (x, y, x + 90, y - 90); 
		m_rect[i][j].NormalizeRect(); 
	} 
} 

}

CTicView::~CTicView()
{
}

BOOL CTicView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTicView drawing

void CTicView::OnDraw(CDC* pDC)
{
	CTicDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//
	//    MM_LOENGLISH,
	//        0,01 .
	//
	pDC->SetMapMode (MM_LOENGLISH);
    ShowFonts(pDC);
	ShowPens(pDC);
	Shfnt(pDC);

	//
	//   .
	//
	for (int i=0; i<m; i++) { 
		for (int j=0; j<l; j++) { 
			pDC->Rectangle (m_rect[i][j]);
        	BYTE bVal = pDoc->GetSquare (i,j);
        	if (bVal == 1)		//  
          	DrawX (pDC, &m_rect[i][j]);
        	else if (bVal == 2)	//  
          	Draw0 (pDC, &m_rect[i][j]);

		}
	}
	
}



/////////////////////////////////////////////////////////////////////////////
// CTicView printing

BOOL CTicView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTicView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTicView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CTicView diagnostics

#ifdef _DEBUG
void CTicView::AssertValid() const
{
	CView::AssertValid();
}

void CTicView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTicDoc* CTicView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTicDoc)));
	return (CTicDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTicView message handlers

void CTicView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CTicDoc* pDoc = GetDocument ();
	// TODO: Add your message handler code here and/or call default
    CClientDC dc (this);
	dc.SetMapMode (MM_LOENGLISH);
	dc.DPtoLP (&point);
	int ars = 0;
	int art = 0;
	int iks = 0;
	int igr = 0;
	int zet = 0;
	int zro = 0;
	int mek = 0;
	int erku = 0;
	int jer = 0;
	int chors = 0;
	int hing = 0;
	int vec = 0;
	int jot = 0;
	int utt = 0;
	int hor = 0;
	int vert = 0;

	BOOL bQuit = FALSE;
	for (int i=0; i<m && !bQuit; i++) { 
		for (int j=0; j<l &&!bQuit; j++) { 
			if (m_rect[i][j].PtInRect (point)) { 
				if (pDoc->GetSquare (i, j) == 0)  {
					if (pDoc->IsItXsTurn()) {
               		    pDoc->AddX(i, j);
                		DrawX (&dc, &m_rect[i][j]);
						
               	} else {
                 	pDoc->AddO(i, j);
                 	Draw0(&dc, &m_rect[i][j]);
				}
				}
				
				bQuit = TRUE;
				
			} 
		} 
	}
	pDoc->Arsen(ars, art);
	pDoc->Arthur(iks, igr, zet, zro, mek, erku);
	pDoc->Goharik(jer, chors, hing, vec, jot, utt);
	pDoc->Haj(hor, vert);
	CView::OnLButtonDown(nFlags, point);
}


void CTicView::DrawX(CDC *pDC, CRect *pRect)
{
	//
	CRect rect;
	rect.CopyRect (pRect);
	rect.DeflateRect (20, 20);

	//
	//       .
	//
	CPen pen (PS_SOLID, 10, RGB (255, 100, 230));
	CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->MoveTo (rect.left, rect.top);
	pDC->LineTo (rect.right, rect.bottom);
	pDC->MoveTo (rect.left, rect.bottom);
	pDC->LineTo (rect.right, rect.top);
	pDC->SelectObject (pOldPen);


}

void CTicView::Draw0(CDC *pDC, CRect *pRect)
{
	CRect rect;
	rect.CopyRect (pRect);
	rect.DeflateRect (20, 20);

	//
	//       0.
	//
	CPen pen (PS_SOLID, 10, RGB (50, 180, 230));
	CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectStockObject (NULL_BRUSH);

	pDC->Ellipse (rect);

	pDC->SelectObject (pOldPen);


}

void CTicView::ShowFonts(CDC *pDC)
{
    CPen pen (PS_SOLID, 5, RGB (0, 0, 0));
	CPen* pOldPen = pDC->SelectObject (&pen);

    pDC->SetTextColor(RGB(0, 60, 55));
	pDC->SetMapMode (MM_LOENGLISH);
	    // Initialize a LOGFONT structure for the fonts.
    LOGFONT logFont;
    logFont.lfHeight = 20;
    logFont.lfWidth = 15;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_EXTRABOLD;
    logFont.lfItalic = 1;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
    strcpy(logFont.lfFaceName, "Arial Armenian");
    // Initialize the position of text in the window.

	 CFont font;
         font.CreateFontIndirect(&logFont);
         CFont* oldFont = pDC->SelectObject(&font);
         // Print text with the new font.
         
		 pDC->TextOut(15, -400, " ˳ һ ѳٳ  :");
         // Restore the old font to the DC.
         pDC->SelectObject(oldFont);
         
         // Restore the old font to the DC.
         
}

void CTicView::ShowPens(CDC *pDC)
{
	CPen pen(PS_SOLID, 5, RGB(50, 0, 230));
          CPen* oldPen = pDC->SelectObject(&pen);
          // Draw a line with the new pen.
	
		  int g;
		  g = -425;
		         
          pDC->MoveTo(10, g);
          pDC->LineTo(650, g);
		  g -= 10;
		  pDC->MoveTo(10, g);
          pDC->LineTo(650, g);
		 
          // Restore the old pen to the DC.
          pDC->SelectObject(oldPen);

}

void CTicView::Shfnt(CDC *pDC)
{
	pDC->SetTextColor(RGB(0, 60, 80));
	pDC->SetMapMode (MM_LOENGLISH);
	    // Initialize a LOGFONT structure for the fonts.
    LOGFONT logFont;
    logFont.lfHeight = 25;
    logFont.lfWidth = 10;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_EXTRABOLD;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
    strcpy(logFont.lfFaceName, "Arial Armenian");
    // Initialize the position of text in the window.

	 CFont font;
         font.CreateFontIndirect(&logFont);
         CFont* oldFont = pDC->SelectObject(&font);
         // Print text with the new font.
         
		 pDC->TextOut(20, -20, "  Tic-tac-toe ˳ !!!");
         pDC->TextOut(420, -150, " ӳ ׳ ٻ  ");
		 pDC->TextOut(400, -200, " ݹݻ  ٻ:");

         // Restore the old font to the DC.
         pDC->SelectObject(oldFont);

}
